/* @license
	On-screen keyboard detector (OSKD) v.2.0.1
	(c) 2020-2020 Matthias Seemann
	OSKD may be freely distributed under the MIT license.
*/
!function(t,n){"object"==typeof exports&&"undefined"!=typeof module?n(exports):"function"==typeof define&&define.amd?define(["exports"],n):n((t=t||self).OSKD={})}(this,(function(t){"use strict";
/** @license MIT License (c) copyright 2010-2016 original author or authors */function n(t,n){for(var e=n.length,r=new Array(e+1),i=0;i<e;++i)r[i]=n[i];return r[e]=t,r}function e(t,n,e){for(var r=n,i=0,s=e.length;i<s;++i)r=t(r,e[i],i);return r}function r(t,n){if(t<0)throw new TypeError("i must be >= 0");var e=n.length;return 0===e||t>=e?n:1===e?[]:function(t,n,e){var r=new Array(e),i=void 0;for(i=0;i<t;++i)r[i]=n[i];for(i=t;i<e;++i)r[i]=n[i+1];return r}(t,n,e-1)}function i(t,n){for(var e=0,r=n.length;e<r;++e)if(t===n[e])return e;return-1}
/** @license MIT License (c) copyright 2010-2016 original author or authors */var s=function(t){return t};function o(t){return function n(e,r){switch(arguments.length){case 0:return n;case 1:return function(n){return t(e,n)};default:return t(e,r)}}}function u(t){return function n(e,r,i){switch(arguments.length){case 0:return n;case 1:return o((function(n,r){return t(e,n,r)}));case 2:return function(n){return t(e,r,n)};default:return t(e,r,i)}}}var c=function(t,n){if(!(t instanceof n))throw new TypeError("Cannot call a class as a function")},h=function(){function t(n,e,r,i,s){c(this,t),this.time=n,this.localOffset=e,this.period=r,this.task=i,this.scheduler=s,this.active=!0}return t.prototype.run=function(){return this.task.run(this.time-this.localOffset)},t.prototype.error=function(t){return this.task.error(this.time-this.localOffset,t)},t.prototype.dispose=function(){return this.active=!1,this.scheduler.cancel(this),this.task.dispose()},t}(),f=function(){function t(n,e){c(this,t),this.origin=n,this.scheduler=e}return t.prototype.currentTime=function(){return this.scheduler.currentTime()-this.origin},t.prototype.scheduleTask=function(t,n,e,r){return this.scheduler.scheduleTask(t+this.origin,n,e,r)},t.prototype.relative=function(n){return new t(n+this.origin,this.scheduler)},t.prototype.cancel=function(t){return this.scheduler.cancel(t)},t.prototype.cancelAll=function(t){return this.scheduler.cancelAll(t)},t}(),a=function(t){return Promise.resolve(t).then(p)};
/** @license MIT License (c) copyright 2010-2017 original author or authors */function p(t){try{return t.run()}catch(n){return t.error(n)}}
/** @license MIT License (c) copyright 2010-2017 original author or authors */var l=function(){function t(n,e){var r=this;c(this,t),this.timer=n,this.timeline=e,this._timer=null,this._nextArrival=1/0,this._runReadyTasksBound=function(){return r._runReadyTasks(r.currentTime())}}return t.prototype.currentTime=function(){return this.timer.now()},t.prototype.scheduleTask=function(t,n,e,r){var i=this.currentTime()+Math.max(0,n),s=new h(i,t,e,r,this);return this.timeline.add(s),this._scheduleNextRun(),s},t.prototype.relative=function(t){return new f(t,this)},t.prototype.cancel=function(t){t.active=!1,this.timeline.remove(t)&&this._reschedule()},t.prototype.cancelAll=function(t){this.timeline.removeAll(t),this._reschedule()},t.prototype._reschedule=function(){this.timeline.isEmpty()?this._unschedule():this._scheduleNextRun(this.currentTime())},t.prototype._unschedule=function(){this.timer.clearTimer(this._timer),this._timer=null},t.prototype._scheduleNextRun=function(){if(!this.timeline.isEmpty()){var t=this.timeline.nextArrival();null===this._timer?this._scheduleNextArrival(t):t<this._nextArrival&&(this._unschedule(),this._scheduleNextArrival(t))}},t.prototype._scheduleNextArrival=function(t){this._nextArrival=t;var n=Math.max(0,t-this.currentTime());this._timer=this.timer.setTimer(this._runReadyTasksBound,n)},t.prototype._runReadyTasks=function(){this._timer=null,this.timeline.runTasks(this.currentTime(),p),this._scheduleNextRun()},t}(),d=function(){function t(){c(this,t),this.tasks=[]}return t.prototype.nextArrival=function(){return this.isEmpty()?1/0:this.tasks[0].time},t.prototype.isEmpty=function(){return 0===this.tasks.length},t.prototype.add=function(t){y(t,this.tasks)},t.prototype.remove=function(t){var n=w(m(t),this.tasks);if(n>=0&&n<this.tasks.length){var e=this.tasks[n].events,r=i(t,e);if(r>=0)return e.splice(r,1),0===e.length&&this.tasks.splice(n,1),!0}return!1},t.prototype.removeAll=function(t){for(var n=0;n<this.tasks.length;++n)g(t,this.tasks[n])},t.prototype.runTasks=function(t,n){for(var e=this.tasks,r=e.length,i=0;i<r&&e[i].time<=t;)++i;this.tasks=e.slice(i);for(var s=0;s<i;++s)this.tasks=v(n,e[s].events,this.tasks)},t}();
/** @license MIT License (c) copyright 2010-2017 original author or authors */function v(t,n,e){for(var r=0;r<n.length;++r){var i=n[r];i.active&&(t(i),i.period>=0&&i.active&&(i.time=i.time+i.period,y(i,e)))}return e}function y(t,n){var e=n.length,r=m(t);if(0!==e){var i=w(r,n);i>=e?n.push(k(r,[t])):function(t,n,e,r){var i=n[r];e===i.time?function(t,n){0===n.length||t.time>=n[n.length-1].time?n.push(t):function(t,n){for(var e=0;e<n.length;e++)if(t.time<n[e].time){n.splice(e,0,t);break}}(t,n)}(t,i.events):n.splice(r,0,k(e,[t]))}(t,n,r,i)}else n.push(k(r,[t]))}function m(t){return Math.floor(t.time)}function g(t,n){n.events=function(t,n){for(var e,r=n.length,i=new Array(r),s=0,o=0;o<r;++o)t(e=n[o])||(i[s]=e,++s);return i.length=s,i}(t,n.events)}function w(t,n){for(var e=0,r=n.length,i=void 0,s=void 0;e<r;){if(t===(s=n[i=Math.floor((e+r)/2)]).time)return i;t<s.time?r=i:e=i+1}return r}var k=function(t,n){return{time:t,events:n}},_=function(){function t(n){c(this,t),this._clock=n}return t.prototype.now=function(){return this._clock.now()},t.prototype.setTimer=function(t,n){return n<=0?function(t){var n=new b(t);return a(n),n}
/** @license MIT License (c) copyright 2010-2017 original author or authors */(t):setTimeout(t,n)},t.prototype.clearTimer=function(t){return t instanceof b?t.cancel():clearTimeout(t)},t}(),b=function(){function t(n){c(this,t),this.f=n,this.active=!0}return t.prototype.run=function(){return this.active&&this.f()},t.prototype.error=function(t){throw t},t.prototype.cancel=function(){this.active=!1},t}();
/** @license MIT License (c) copyright 2010-2017 original author or authors */var O=function(){function t(n,e){c(this,t),this.origin=e,this.clock=n}return t.prototype.now=function(){return this.clock.now()-this.origin},t}(),T=function(){function t(n,e){c(this,t),this.origin=e,this.hrtime=n}return t.prototype.now=function(){var t=this.hrtime(this.origin);return(1e9*t[0]+t[1])/1e6},t}(),A=function(t){return new O(t,t.now())},S=function(){return"undefined"!=typeof performance&&"function"==typeof performance.now?A(performance):"undefined"!=typeof process&&"function"==typeof process.hrtime?new T(process.hrtime,process.hrtime()):A(Date)},x=function(t){return t.currentTime()},E=o((function(t,n){return n.scheduleTask(0,0,-1,t)})),j=u((function(t,n,e){return e.scheduleTask(0,t,-1,n)})),I=function(t){return t.dispose()},H=o((function(t,n){return new f(t,n)})),q=function(){return new l(z(),new d)},z=function(){return new _(S())},R=function(t,n){if(!(t instanceof n))throw new TypeError("Cannot call a class as a function")},N=function(){return P},P=new(function(){function t(){R(this,t)}return t.prototype.dispose=function(){},t}()),C=function(t){return new D(t)},D=function(){function t(n){R(this,t),this.disposed=!1,this.disposable=n}return t.prototype.dispose=function(){this.disposed||(this.disposed=!0,this.disposable.dispose(),this.disposable=void 0)},t}(),M=function(t){var n=e(B,[],t);return 0===n.length?N():new L(n)},V=o((function(t,n){return M([t,n])})),B=function(t,e){return function(t){return t===P}(e)?t:e instanceof L?t.concat(e.disposables):n(e,t)},L=function(){function t(n){R(this,t),this.disposables=n}return t.prototype.dispose=function(){F(U(this.disposables))},t}(),U=function(t){return e(W,[],t)},W=function(t,n){try{n.dispose()}catch(n){t.push(n)}return t},F=function(t){if(t.length>0)throw new J(t.length+" errors",t)},J=function(t){function n(e,r){t.call(this,e),this.message=e,this.name=n.name,this.errors=r,t.captureStackTrace&&t.captureStackTrace(this,n),this.stack=""+this.stack+K(this.errors)}return n.prototype=Object.create(t.prototype),n}(Error),K=function(t){return e(X,"",t)},X=function(t,n,e){return t+"\n["+(e+1)+"] "+n.stack},G=u((function(t,n,e){try{n.dispose()}catch(n){e.error(t,n)}}));function Q(t){throw t}var Y=function(t,n){if(!(t instanceof n))throw new TypeError("Cannot call a class as a function")},Z=function(t,n){if("function"!=typeof n&&null!==n)throw new TypeError("Super expression must either be null or a function, not "+typeof n);t.prototype=Object.create(n&&n.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),n&&(Object.setPrototypeOf?Object.setPrototypeOf(t,n):t.__proto__=n)},$=function(t,n){if(!t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!n||"object"!=typeof n&&"function"!=typeof n?t:n},tt=function(t,n,e){return new rt(t,n,e)},nt=function(t,n){return tt(it,t,n)},et=function(t){return tt(st,void 0,t)},rt=function(){function t(n,e,r){Y(this,t),this._run=n,this.value=e,this.sink=r,this.active=!0}return t.prototype.dispose=function(){this.active=!1},t.prototype.run=function(t){if(this.active){var n=this._run;n(t,this.value,this.sink)}},t.prototype.error=function(t,n){if(!this.active)
/** @license MIT License (c) copyright 2010-2016 original author or authors */
return function(t){setTimeout(Q,0,t)}(n);this.sink.error(t,n)},t}(),it=function(t,n,e){return e.event(t,n)},st=function(t,n,e){return e.end(t)},ot=function(){return ct},ut=function(t){return t===ct},ct=new(function(){function t(){Y(this,t)}return t.prototype.run=function(t,n){return E(et(t),n)},t}()),ht=function(t,n){return new ft(t,n)},ft=function(){function t(n,e){Y(this,t),this.time=n,this.value=e}return t.prototype.run=function(t,n){return j(this.time,tt(at,this.value,t),n)},t}();function at(t,n,e){e.event(t,n),e.end(t)}
/** @license MIT License (c) copyright 2010-2017 original author or authors */var pt=function(t){return ht(0,t)},lt=function(){function t(n){Y(this,t),this.sink=n}return t.prototype.event=function(t,n){return this.sink.event(t,n)},t.prototype.end=function(t){return this.sink.end(t)},t.prototype.error=function(t,n){return this.sink.error(t,n)},t}(),dt=function(){function t(n,e){Y(this,t),this.p=n,this.source=e}return t.prototype.run=function(t,n){return this.source.run(new vt(this.p,t),n)},t.create=function(n,e){return ut(e)?e:e instanceof t?new t(yt(e.p,n),e.source):new t(n,e)},t}(),vt=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.p=e,i}return Z(n,t),n.prototype.event=function(t,n){(0,this.p)(n)&&this.sink.event(t,n)},n}(lt),yt=function(t,n){return function(e){return t(e)&&n(e)}},mt=function(){function t(n,e,r){Y(this,t),this.p=n,this.f=e,this.source=r}return t.prototype.run=function(t,n){return this.source.run(new gt(this.p,this.f,t),n)},t}(),gt=function(t){function n(e,r,i){Y(this,n);var s=$(this,t.call(this,i));return s.p=e,s.f=r,s}return Z(n,t),n.prototype.event=function(t,n){var e=this.f;(0,this.p)(n)&&this.sink.event(t,e(n))},n}(lt),wt=function(){function t(n,e){Y(this,t),this.f=n,this.source=e}return t.prototype.run=function(t,n){return this.source.run(new kt(this.f,t),n)},t.create=function(n,e){return ut(e)?ot():e instanceof t?new t(function(t,n){return function(e){return t(n(e))}}(n,e.f),e.source):e instanceof dt?new mt(e.p,n,e.source):new t(n,e)},t}(),kt=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.f=e,i}return Z(n,t),n.prototype.event=function(t,n){var e=this.f;this.sink.event(t,e(n))},n}(lt),_t=function(){function t(){Y(this,t),this.disposable=void 0,this.disposed=!1}return t.prototype.setDisposable=function(t){if(void 0!==this.disposable)throw new Error("setDisposable called more than once");this.disposable=t,this.disposed&&t.dispose()},t.prototype.dispose=function(){this.disposed||(this.disposed=!0,void 0!==this.disposable&&this.disposable.dispose())},t}(),bt=function(t,n){return ut(n)?ot():new Ot(t,n)},Ot=function(){function t(n,e){Y(this,t),this.p=n,this.source=e}return t.prototype.run=function(t,n){return this.source.run(new Tt(this.p,t),n)},t}(),Tt=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.p=e,i.skipping=!1,i}return Z(n,t),n.prototype.event=function(t,n){if(!this.skipping){var e=this.p;this.skipping=e(n),this.sink.event(t,n),this.skipping&&this.sink.end(t)}},n}(lt),At=o((function(t,n){return new Promise((function(e,r){return function(t,n,e,r){var i=new _t,s=new St(e,r,i);i.setDisposable(t.run(s,n))}(t,n,e,r)}))}));
/** @license MIT License (c) copyright 2010-2017 original author or authors */var St=function(){function t(n,e,r){Y(this,t),this._end=n,this._error=e,this._disposable=r,this.active=!0}return t.prototype.event=function(t,n){},t.prototype.end=function(t){this.active&&this._dispose(this._error,this._end,void 0)},t.prototype.error=function(t,n){this._dispose(this._error,this._error,n)},t.prototype._dispose=function(t,n,e){this.active=!1,function(t,n,e,r){try{r.dispose()}catch(n){return void t(n)}n(e)}
/** @license MIT License (c) copyright 2010-2017 original author or authors */(t,n,e,this._disposable)},t}();var xt=function(){function t(n,e){Y(this,t),this.sink=e,this.offset=n}return t.prototype.event=function(t,n){this.sink.event(t+this.offset,n)},t.prototype.error=function(t,n){this.sink.error(t+this.offset,n)},t.prototype.end=function(t){this.sink.end(t+this.offset)},t}(),Et=function(){function t(n,e){Y(this,t),this.origin=n,this.source=e}return t.prototype.run=function(t,n){return this.source.run(jt(this.origin,t),H(this.origin,n))},t}(),jt=function(t,n){return n instanceof xt?new xt(t+n.offset,n.sink):new xt(t,n)},It=function(t,n,e){return new Ht(t,n,e)},Ht=function(){function t(n,e,r){Y(this,t),this.source=r,this.f=n,this.value=e}return t.prototype.run=function(t,n){var e=E(nt(this.value,t),n),r=this.source.run(new qt(this.f,this.value,t),n);return V(e,r)},t}(),qt=function(t){function n(e,r,i){Y(this,n);var s=$(this,t.call(this,i));return s.f=e,s.value=r,s}return Z(n,t),n.prototype.event=function(t,n){var e=this.f;this.value=e(this.value,n),this.sink.event(t,this.value)},n}(lt),zt=function(){function t(n,e){Y(this,t),this.f=n,this.source=e}return t.prototype.run=function(t,n){return new Rt(this.f,this.source,t,n)},t}(),Rt=function(t){function n(e,r,i,s){Y(this,n);var o=$(this,t.call(this,i));return o.f=e,o.scheduler=s,o.active=!0,o.disposable=C(r.run(o,s)),o}return Z(n,t),n.prototype.event=function(t,n){this.active&&this.sink.event(t,n)},n.prototype.end=function(t){this.active&&(G(t,this.disposable,this.sink),this._startNext(t,this.sink))},n.prototype._startNext=function(t,n){try{this.disposable=this._continue(this.f,t,n)}catch(e){n.error(t,e)}},n.prototype._continue=function(t,n,e){return function(t,n,e){return e.run(t,n)}(e,this.scheduler,(r=n,i=t(),new Et(r,i)));var r,i},n.prototype.dispose=function(){return this.active=!1,this.disposable.dispose()},n}(lt),Nt=function(t,n){return function(t,n){return new zt(t,n)}((function(){return n}),pt(t))},Pt=function(t,n){return wt.create(t,n)},Ct=function(t,n){return new Dt(t,n)},Dt=function(){function t(n,e){Y(this,t),this.source=e,this.f=n}return t.prototype.run=function(t,n){return this.source.run(new Mt(this.f,t),n)},t}(),Mt=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.f=e,i}return Z(n,t),n.prototype.event=function(t,n){(0,this.f)(n),this.sink.event(t,n)},n}(lt),Vt=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.index=e,i.active=!0,i.value=void 0,i}return Z(n,t),n.prototype.event=function(t,n){this.active&&(this.value=n,this.sink.event(t,this))},n.prototype.end=function(t){this.active&&(this.active=!1,this.sink.event(t,this))},n}(lt),Bt=function(t,n,e){return ut(e)?ot():new Lt(t,n,e)},Lt=function(){function t(n,e,r){Y(this,t),this.f=n,this.concurrency=e,this.source=r}return t.prototype.run=function(t,n){return new Ut(this.f,this.concurrency,this.source,t,n)},t}(),Ut=function(){function t(n,e,r,i,s){Y(this,t),this.f=n,this.concurrency=e,this.sink=i,this.scheduler=s,this.pending=[],this.current=[],this.disposable=C(r.run(this,s)),this.active=!0}return t.prototype.event=function(t,n){this._addInner(t,n)},t.prototype._addInner=function(t,n){this.current.length<this.concurrency?this._startInner(t,n):this.pending.push(n)},t.prototype._startInner=function(t,n){try{this._initInner(t,n)}catch(n){this.error(t,n)}},t.prototype._initInner=function(t,n){var e=new Ft(t,this,this.sink);e.disposable=Wt(this.f,t,n,e,this.scheduler),this.current.push(e)},t.prototype.end=function(t){this.active=!1,G(t,this.disposable,this.sink),this._checkEnd(t)},t.prototype.error=function(t,n){this.active=!1,this.sink.error(t,n)},t.prototype.dispose=function(){this.active=!1,this.pending.length=0,this.disposable.dispose(),M(this.current).dispose()},t.prototype._endInner=function(t,n){var e=this.current.indexOf(n);e>=0&&this.current.splice(e,1),G(t,n,this),0===this.pending.length?this._checkEnd(t):this._startInner(t,this.pending.shift())},t.prototype._checkEnd=function(t){this.active||0!==this.current.length||this.sink.end(t)},t}(),Wt=function(t,n,e,r,i){return t(e).run(r,H(n,i))},Ft=function(){function t(n,e,r){Y(this,t),this.time=n,this.outer=e,this.sink=r,this.disposable=N()}return t.prototype.event=function(t,n){this.sink.event(t+this.time,n)},t.prototype.end=function(t){this.outer._endInner(t+this.time,this)},t.prototype.error=function(t,n){this.outer.error(t+this.time,n)},t.prototype.dispose=function(){return this.disposable.dispose()},t}(),Jt=function(t){return function(t,n){return Bt(s,t,n)}(1/0,t)};
/** @license MIT License (c) copyright 2010-2016 original author or authors */
function Kt(t,n){return Xt([t,n])}var Xt=function(t){return Gt(Qt(t))},Gt=function(t){return 0===t.length?ot():1===t.length?t[0]:new $t(e(Zt,[],t))},Qt=function(t){return t.filter(Yt)},Yt=function(t){return!ut(t)},Zt=function(t,n){return t.concat(n instanceof $t?n.sources:n)},$t=function(){function t(n){Y(this,t),this.sources=n}return t.prototype.run=function(t,n){for(var e,r=this.sources.length,i=new Array(r),s=new Array(r),o=new tn(i,s,t),u=0;u<r;++u)e=s[u]=new Vt(u,o),i[u]=this.sources[u].run(e,n);return M(i)},t}(),tn=function(t){function n(e,r,i){Y(this,n);var s=$(this,t.call(this,i));return s.disposables=e,s.activeCount=r.length,s}return Z(n,t),n.prototype.event=function(t,n){n.active?this.sink.event(t,n.value):this._dispose(t,n.index)},n.prototype._dispose=function(t,n){G(t,this.disposables[n],this.sink),0==--this.activeCount&&this.sink.end(t)},n}(lt),nn=function(t,n,e){return ut(e)||ut(n)?ot():new en(t,n,e)},en=function(){function t(n,e,r){Y(this,t),this.f=n,this.values=e,this.sampler=r}return t.prototype.run=function(t,n){var e=new rn(this.f,t),r=this.values.run(e.latest,n),i=this.sampler.run(e,n);return V(i,r)},t}(),rn=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.f=e,i.latest=new sn(i),i}return Z(n,t),n.prototype.event=function(t,n){if(this.latest.hasValue){var e=this.f;this.sink.event(t,e(this.latest.value,n))}},n}(lt),sn=function(t){function n(e){Y(this,n);var r=$(this,t.call(this,e));return r.hasValue=!1,r}return Z(n,t),n.prototype.event=function(t,n){this.value=n,this.hasValue=!0},n.prototype.end=function(){},n}(lt),on=function(t){return ut(t)?ot():new un(t)},un=function(){function t(n){Y(this,t),this.source=n}return t.prototype.run=function(t,n){var e=new cn(t,n);return V(e,this.source.run(e,n))},t}(),cn=function(){function t(n,e){Y(this,t),this.sink=n,this.scheduler=e,this.current=null,this.ended=!1}return t.prototype.event=function(t,n){this._disposeCurrent(t),this.current=new hn(n,t,1/0,this,this.sink,this.scheduler)},t.prototype.end=function(t){this.ended=!0,this._checkEnd(t)},t.prototype.error=function(t,n){this.ended=!0,this.sink.error(t,n)},t.prototype.dispose=function(){return this._disposeCurrent(x(this.scheduler))},t.prototype._disposeCurrent=function(t){if(null!==this.current)return this.current._dispose(t)},t.prototype._disposeInner=function(t,n){n._dispose(t),n===this.current&&(this.current=null)},t.prototype._checkEnd=function(t){this.ended&&null===this.current&&this.sink.end(t)},t.prototype._endInner=function(t,n){this._disposeInner(t,n),this._checkEnd(t)},t.prototype._errorInner=function(t,n,e){this._disposeInner(t,e),this.sink.error(t,n)},t}(),hn=function(){function t(n,e,r,i,s,o){Y(this,t),this.min=e,this.max=r,this.outer=i,this.sink=s,this.disposable=n.run(this,H(e,o))}return t.prototype.event=function(t,n){var e=Math.max(0,t+this.min);e<this.max&&this.sink.event(e,n)},t.prototype.end=function(t){this.outer._endInner(t+this.min,this)},t.prototype.error=function(t,n){this.outer._errorInner(t+this.min,n,this)},t.prototype._dispose=function(t){G(t,this.disposable,this.sink)},t}(),fn=function(t,n){return dt.create(t,n)},an=function(t){return pn(vn,t)},pn=function(t,n){return ut(n)?ot():new ln(t,n)},ln=function(){function t(n,e){Y(this,t),this.equals=n,this.source=e}return t.prototype.run=function(t,n){return this.source.run(new dn(this.equals,t),n)},t}(),dn=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,r));return i.equals=e,i.value=void 0,i.init=!0,i}return Z(n,t),n.prototype.event=function(t,n){this.init?(this.init=!1,this.value=n,this.sink.event(t,n)):this.equals(this.value,n)||(this.value=n,this.sink.event(t,n))},n}(lt);function vn(t,n){return t===n}
/** @license MIT License (c) copyright 2010-2016 original author or authors */var yn=function(t,n){return new mn(t,n)},mn=function(){function t(n,e){Y(this,t),this.maxSignal=n,this.source=e}return t.prototype.run=function(t,n){var e=new _t,r=this.source.run(t,n),i=this.maxSignal.run(new gn(t,e),n);return e.setDisposable(V(r,i)),e},t}(),gn=function(t){function n(e,r){Y(this,n);var i=$(this,t.call(this,e));return i.disposable=r,i}return Z(n,t),n.prototype.event=function(t,n){this.disposable.dispose(),this.sink.end(t)},n.prototype.end=function(){},n}(lt),wn=function(t,n){return t<=0?n:new kn(t,n)},kn=function(){function t(n,e){Y(this,t),this.dt=n,this.source=e}return t.prototype.run=function(t,n){var e=new _n(this.dt,t,n);return V(e,this.source.run(e,n))},t}(),_n=function(t){function n(e,r,i){Y(this,n);var s=$(this,t.call(this,r));return s.dt=e,s.scheduler=i,s.tasks=[],s}return Z(n,t),n.prototype.dispose=function(){this.tasks.forEach(I)},n.prototype.event=function(t,n){this.tasks.push(j(this.dt,nt(n,this.sink),this.scheduler))},n.prototype.end=function(t){this.tasks.push(j(this.dt,et(this.sink),this.scheduler))},n}(lt),bn=function(t,n){return ut(n)?ot():new On(t,n)},On=function(){function t(n,e){Y(this,t),this.dt=n,this.source=e}return t.prototype.run=function(t,n){return new Tn(this.dt,this.source,t,n)},t}(),Tn=function(){function t(n,e,r,i){Y(this,t),this.dt=n,this.sink=r,this.scheduler=i,this.value=void 0,this.timer=null,this.disposable=e.run(this,i)}return t.prototype.event=function(t,n){this._clearTimer(),this.value=n,this.timer=j(this.dt,new An(this,n),this.scheduler)},t.prototype._event=function(t,n){this._clearTimer(),this.sink.event(t,n)},t.prototype.end=function(t){this._clearTimer()&&(this.sink.event(t,this.value),this.value=void 0),this.sink.end(t)},t.prototype.error=function(t,n){this._clearTimer(),this.sink.error(t,n)},t.prototype.dispose=function(){this._clearTimer(),this.disposable.dispose()},t.prototype._clearTimer=function(){return null!==this.timer&&(this.timer.dispose(),this.timer=null,!0)},t}(),An=function(){function t(n,e){Y(this,t),this.debounce=n,this.value=e}return t.prototype.run=function(t){this.debounce._event(t,this.value)},t.prototype.error=function(t,n){this.debounce.error(t,n)},t.prototype.dispose=function(){},t}();
/** @license MIT License (c) copyright 2010-2016 original author or authors */
function Sn(t,n,e){try{e.event(t,n)}catch(n){e.error(t,n)}}function xn(t,n){try{n.end(t)}catch(e){n.error(t,e)}}var En=function(t){return t instanceof jn||ut(t)?t:new jn(t)},jn=function(){function t(n){Y(this,t),this.source=new In(n)}return t.prototype.run=function(t,n){return this.source.run(t,n)},t}(),In=function(){function t(n){Y(this,t),this.source=n,this.sinks=[],this.disposable=N()}return t.prototype.run=function(t,n){return 1===this.add(t)&&(this.disposable=this.source.run(this,n)),C(new Hn(this,t))},t.prototype.dispose=function(){var t=this.disposable;return this.disposable=N(),t.dispose()},t.prototype.add=function(t){return this.sinks=n(t,this.sinks),this.sinks.length},t.prototype.remove=function(t){var n=i(t,this.sinks);return n>=0&&(this.sinks=r(n,this.sinks)),this.sinks.length},t.prototype.event=function(t,n){var e=this.sinks;if(1===e.length)return e[0].event(t,n);for(var r=0;r<e.length;++r)Sn(t,n,e[r])},t.prototype.end=function(t){for(var n=this.sinks,e=0;e<n.length;++e)xn(t,n[e])},t.prototype.error=function(t,n){for(var e=this.sinks,r=0;r<e.length;++r)e[r].error(t,n)},t}(),Hn=function(){function t(n,e){Y(this,t),this.source=n,this.sink=e}return t.prototype.dispose=function(){0===this.source.remove(this.sink)&&this.source.dispose()},t}(),qn=o(At),zn=u(It),Rn=o(Nt),Nn=o(Pt),Pn=o(Ct),Cn=o(Kt),Dn=u(nn),Mn=o(fn),Vn=o(bt),Bn=o(yn),Ln=o(wn),Un=o(bn),Wn=function(t,n,e){return void 0===e&&(e=!1),new Gn(t,n,e)},Fn=function(t,n){return void 0===n&&(n=!1),Wn("focusin",t,n)},Jn=function(t,n){return void 0===n&&(n=!1),Wn("focusout",t,n)},Kn=function(t,n){return void 0===n&&(n=!1),Wn("change",t,n)},Xn=function(t,n){return void 0===n&&(n=!1),Wn("resize",t,n)},Gn=function(t,n,e){this.event=t,this.node=n,this.capture=e};Gn.prototype.run=function(t,n){var e=this,r=function(e){return function(t,n,e){try{e.event(t,n)}catch(n){e.error(t,n)}}(x(n),e,t)};return this.node.addEventListener(this.event,r,this.capture),{dispose:function(){return e.node.removeEventListener(e.event,r,e.capture)}}};var Qn=function(){var t=[];return[function(n){return Yn(t,n)},new Zn(t)]},Yn=function(t,n){return t.forEach((function(t){var e=t.sink;return function(t,n,e){try{e.event(t,n)}catch(n){e.error(t,n)}}(t.scheduler.currentTime(),n,e)}))},Zn=function(){function t(t){this.sinks=t}return t.prototype.run=function(t,n){var e={sink:t,scheduler:n};return this.sinks.push(e),new $n(e,this.sinks)},t}(),$n=function(){function t(t,n){this.sink=t,this.sinks=n}return t.prototype.dispose=function(){var t=this.sinks.indexOf(this.sink);t>=0&&this.sinks.splice(t,1)},t}();function te(t){return null!=t&&"object"==typeof t&&!0===t["@@functional/placeholder"]}function ne(t){return function n(e){return 0===arguments.length||te(e)?n:t.apply(this,arguments)}}function ee(t){return function n(e,r){switch(arguments.length){case 0:return n;case 1:return te(e)?n:ne((function(n){return t(e,n)}));default:return te(e)&&te(r)?n:te(e)?ne((function(n){return t(n,r)})):te(r)?ne((function(n){return t(e,n)})):t(e,r)}}}function re(t,n){switch(t){case 0:return function(){return n.apply(this,arguments)};case 1:return function(t){return n.apply(this,arguments)};case 2:return function(t,e){return n.apply(this,arguments)};case 3:return function(t,e,r){return n.apply(this,arguments)};case 4:return function(t,e,r,i){return n.apply(this,arguments)};case 5:return function(t,e,r,i,s){return n.apply(this,arguments)};case 6:return function(t,e,r,i,s,o){return n.apply(this,arguments)};case 7:return function(t,e,r,i,s,o,u){return n.apply(this,arguments)};case 8:return function(t,e,r,i,s,o,u,c){return n.apply(this,arguments)};case 9:return function(t,e,r,i,s,o,u,c,h){return n.apply(this,arguments)};case 10:return function(t,e,r,i,s,o,u,c,h,f){return n.apply(this,arguments)};default:throw new Error("First argument to _arity must be a non-negative integer no greater than ten")}}var ie=ee((function(t,n){return 1===t?ne(n):re(t,function t(n,e,r){return function(){for(var i=[],s=0,o=n,u=0;u<e.length||s<arguments.length;){var c;u<e.length&&(!te(e[u])||s>=arguments.length)?c=e[u]:(c=arguments[s],s+=1),i[u]=c,te(c)||(o-=1),u+=1}return o<=0?r.apply(this,i):re(o,t(n,i,r))}}(t,[],n))}));function se(t){return function n(e,r,i){switch(arguments.length){case 0:return n;case 1:return te(e)?n:ee((function(n,r){return t(e,n,r)}));case 2:return te(e)&&te(r)?n:te(e)?ee((function(n,e){return t(n,r,e)})):te(r)?ee((function(n,r){return t(e,n,r)})):ne((function(n){return t(e,r,n)}));default:return te(e)&&te(r)&&te(i)?n:te(e)&&te(r)?ee((function(n,e){return t(n,e,i)})):te(e)&&te(i)?ee((function(n,e){return t(n,r,e)})):te(r)&&te(i)?ee((function(n,r){return t(e,n,r)})):te(e)?ne((function(n){return t(n,r,i)})):te(r)?ne((function(n){return t(e,n,i)})):te(i)?ne((function(n){return t(e,r,n)})):t(e,r,i)}}}var oe=Array.isArray||function(t){return null!=t&&t.length>=0&&"[object Array]"===Object.prototype.toString.call(t)};function ue(t){return"[object String]"===Object.prototype.toString.call(t)}var ce=ne((function(t){return!!oe(t)||!!t&&("object"==typeof t&&(!ue(t)&&(1===t.nodeType?!!t.length:0===t.length||t.length>0&&(t.hasOwnProperty(0)&&t.hasOwnProperty(t.length-1)))))})),he=function(){function t(t){this.f=t}return t.prototype["@@transducer/init"]=function(){throw new Error("init not implemented on XWrap")},t.prototype["@@transducer/result"]=function(t){return t},t.prototype["@@transducer/step"]=function(t,n){return this.f(t,n)},t}();var fe=ee((function(t,n){return re(t.length,(function(){return t.apply(n,arguments)}))}));function ae(t,n,e){for(var r=e.next();!r.done;){if((n=t["@@transducer/step"](n,r.value))&&n["@@transducer/reduced"]){n=n["@@transducer/value"];break}r=e.next()}return t["@@transducer/result"](n)}function pe(t,n,e,r){return t["@@transducer/result"](e[r](fe(t["@@transducer/step"],t),n))}var le="undefined"!=typeof Symbol?Symbol.iterator:"@@iterator";function de(t,n,e){if("function"==typeof t&&(t=function(t){return new he(t)}(t)),ce(e))return function(t,n,e){for(var r=0,i=e.length;r<i;){if((n=t["@@transducer/step"](n,e[r]))&&n["@@transducer/reduced"]){n=n["@@transducer/value"];break}r+=1}return t["@@transducer/result"](n)}(t,n,e);if("function"==typeof e["fantasy-land/reduce"])return pe(t,n,e,"fantasy-land/reduce");if(null!=e[le])return ae(t,n,e[le]());if("function"==typeof e.next)return ae(t,n,e);if("function"==typeof e.reduce)return pe(t,n,e,"reduce");throw new TypeError("reduce: list must be array or iterable")}function ve(t,n){return Object.prototype.hasOwnProperty.call(n,t)}var ye=Object.prototype.toString,me=function(){return"[object Arguments]"===ye.call(arguments)?function(t){return"[object Arguments]"===ye.call(t)}:function(t){return ve("callee",t)}}(),ge=!{toString:null}.propertyIsEnumerable("toString"),we=["constructor","valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"],ke=function(){return arguments.propertyIsEnumerable("length")}(),_e=function(t,n){for(var e=0;e<t.length;){if(t[e]===n)return!0;e+=1}return!1},be="function"!=typeof Object.keys||ke?ne((function(t){if(Object(t)!==t)return[];var n,e,r=[],i=ke&&me(t);for(n in t)!ve(n,t)||i&&"length"===n||(r[r.length]=n);if(ge)for(e=we.length-1;e>=0;)ve(n=we[e],t)&&!_e(r,n)&&(r[r.length]=n),e-=1;return r})):ne((function(t){return Object(t)!==t?[]:Object.keys(t)})),Oe=se(de),Te=ne((function(t){return function(){return t}})),Ae=ee((function(t,n){return n(t)})),Se=se((function(t,n,e){var r={};for(var i in e)r[i]=e[i];return r[t]=n,r})),xe=ne((function(t){return ie(t.length,t)})),Ee=ne((function(t){return null===t?"Null":void 0===t?"Undefined":Object.prototype.toString.call(t).slice(8,-1)}));function je(t,n){return function(){return n.call(this,t.apply(this,arguments))}}function Ie(t,n){return function(){var e=arguments.length;if(0===e)return n();var r=arguments[e-1];return oe(r)||"function"!=typeof r[t]?n.apply(this,arguments):r[t].apply(r,Array.prototype.slice.call(arguments,0,e-1))}}var He=ne(Ie("tail",se(Ie("slice",(function(t,n,e){return Array.prototype.slice.call(e,t,n)})))(1,1/0)));function qe(){if(0===arguments.length)throw new Error("pipe requires at least one argument");return re(arguments[0].length,Oe(je,arguments[0],He(arguments)))}var ze=ne((function(t){return ue(t)?t.split("").reverse().join(""):Array.prototype.slice.call(t,0).reverse()}));function Re(){if(0===arguments.length)throw new Error("compose requires at least one argument");return qe.apply(this,ze(arguments))}function Ne(t){for(var n,e=[];!(n=t.next()).done;)e.push(n.value);return e}function Pe(t,n,e){for(var r=0,i=e.length;r<i;){if(t(n,e[r]))return!0;r+=1}return!1}var Ce="function"==typeof Object.is?Object.is:function(t,n){return t===n?0!==t||1/t==1/n:t!=t&&n!=n};function De(t,n,e,r){var i=Ne(t);function s(t,n){return Me(t,n,e.slice(),r.slice())}return!Pe((function(t,n){return!Pe(s,n,t)}),Ne(n),i)}function Me(t,n,e,r){if(Ce(t,n))return!0;var i,s,o=Ee(t);if(o!==Ee(n))return!1;if(null==t||null==n)return!1;if("function"==typeof t["fantasy-land/equals"]||"function"==typeof n["fantasy-land/equals"])return"function"==typeof t["fantasy-land/equals"]&&t["fantasy-land/equals"](n)&&"function"==typeof n["fantasy-land/equals"]&&n["fantasy-land/equals"](t);if("function"==typeof t.equals||"function"==typeof n.equals)return"function"==typeof t.equals&&t.equals(n)&&"function"==typeof n.equals&&n.equals(t);switch(o){case"Arguments":case"Array":case"Object":if("function"==typeof t.constructor&&"Promise"===(i=t.constructor,null==(s=String(i).match(/^function (\w*)/))?"":s[1]))return t===n;break;case"Boolean":case"Number":case"String":if(typeof t!=typeof n||!Ce(t.valueOf(),n.valueOf()))return!1;break;case"Date":if(!Ce(t.valueOf(),n.valueOf()))return!1;break;case"Error":return t.name===n.name&&t.message===n.message;case"RegExp":if(t.source!==n.source||t.global!==n.global||t.ignoreCase!==n.ignoreCase||t.multiline!==n.multiline||t.sticky!==n.sticky||t.unicode!==n.unicode)return!1}for(var u=e.length-1;u>=0;){if(e[u]===t)return r[u]===n;u-=1}switch(o){case"Map":return t.size===n.size&&De(t.entries(),n.entries(),e.concat([t]),r.concat([n]));case"Set":return t.size===n.size&&De(t.values(),n.values(),e.concat([t]),r.concat([n]));case"Arguments":case"Array":case"Object":case"Boolean":case"Number":case"String":case"Date":case"Error":case"RegExp":case"Int8Array":case"Uint8Array":case"Uint8ClampedArray":case"Int16Array":case"Uint16Array":case"Int32Array":case"Uint32Array":case"Float32Array":case"Float64Array":case"ArrayBuffer":break;default:return!1}var c=be(t);if(c.length!==be(n).length)return!1;var h=e.concat([t]),f=r.concat([n]);for(u=c.length-1;u>=0;){var a=c[u];if(!ve(a,n)||!Me(n[a],t[a],h,f))return!1;u-=1}return!0}var Ve=ee((function(t,n){return Me(t,n,[],[])}));function Be(t,n){return function(t,n,e){var r,i;if("function"==typeof t.indexOf)switch(typeof n){case"number":if(0===n){for(r=1/n;e<t.length;){if(0===(i=t[e])&&1/i===r)return e;e+=1}return-1}if(n!=n){for(;e<t.length;){if("number"==typeof(i=t[e])&&i!=i)return e;e+=1}return-1}return t.indexOf(n,e);case"string":case"boolean":case"function":case"undefined":return t.indexOf(n,e);case"object":if(null===n)return t.indexOf(n,e)}for(;e<t.length;){if(Ve(t[e],n))return e;e+=1}return-1}(n,t,0)>=0}var Le=function(){function t(){this._nativeSet="function"==typeof Set?new Set:null,this._items={}}return t.prototype.add=function(t){return!Ue(t,!0,this)},t.prototype.has=function(t){return Ue(t,!1,this)},t}();function Ue(t,n,e){var r,i=typeof t;switch(i){case"string":case"number":return 0===t&&1/t==-1/0?!!e._items["-0"]||(n&&(e._items["-0"]=!0),!1):null!==e._nativeSet?n?(r=e._nativeSet.size,e._nativeSet.add(t),e._nativeSet.size===r):e._nativeSet.has(t):i in e._items?t in e._items[i]||(n&&(e._items[i][t]=!0),!1):(n&&(e._items[i]={},e._items[i][t]=!0),!1);case"boolean":if(i in e._items){var s=t?1:0;return!!e._items[i][s]||(n&&(e._items[i][s]=!0),!1)}return n&&(e._items[i]=t?[!1,!0]:[!0,!1]),!1;case"function":return null!==e._nativeSet?n?(r=e._nativeSet.size,e._nativeSet.add(t),e._nativeSet.size===r):e._nativeSet.has(t):i in e._items?!!Be(t,e._items[i])||(n&&e._items[i].push(t),!1):(n&&(e._items[i]=[t]),!1);case"undefined":return!!e._items[i]||(n&&(e._items[i]=!0),!1);case"object":if(null===t)return!!e._items.null||(n&&(e._items.null=!0),!1);default:return(i=Object.prototype.toString.call(t))in e._items?!!Be(t,e._items[i])||(n&&e._items[i].push(t),!1):(n&&(e._items[i]=[t]),!1)}}var We=ee((function(t,n){for(var e=[],r=0,i=t.length,s=n.length,o=new Le,u=0;u<s;u+=1)o.add(n[u]);for(;r<i;)o.add(t[r])&&(e[e.length]=t[r]),r+=1;return e})),Fe=ne((function(t){return null!=t&&"function"==typeof t["fantasy-land/empty"]?t["fantasy-land/empty"]():null!=t&&null!=t.constructor&&"function"==typeof t.constructor["fantasy-land/empty"]?t.constructor["fantasy-land/empty"]():null!=t&&"function"==typeof t.empty?t.empty():null!=t&&null!=t.constructor&&"function"==typeof t.constructor.empty?t.constructor.empty():oe(t)?[]:ue(t)?"":function(t){return"[object Object]"===Object.prototype.toString.call(t)}(t)?{}:me(t)?function(){return arguments}():void 0})),Je=ee(Ce),Ke=ne((function(t){return null!=t&&Ve(t,Fe(t))})),Xe=se((function(t,n,e){return Ve(n,e[t])}));const Ge="visualViewport"in window;function Qe(){return Ge}const Ye=t=>{var n="_one_time_initial_";return function(e){e!==n&&(n=e,t(e))}};const Ze=/iPhone/.test(navigator.userAgent),$e=()=>screen.orientation.type.startsWith("portrait")?"portrait":"landscape",tr=xe(Re(Jt,Dn((t,n)=>t?ot():pt(n)))),nr=()=>document.activeElement&&document.activeElement!==document.body;t.isSupported=function(){return!Ze||Qe()},t.subscribe=function(t){if(Ze)return function(t){if(!Qe())return console.warn("On-Screen-Keyboard detection not supported on this version of iOS"),()=>void 0;const n=Ye(t),e=t=>{n(t.target.height===window.innerHeight?"hidden":"visible")};return visualViewport.addEventListener("resize",e),function(){visualViewport.removeEventListener("resize",e)}}(t);const n=Math.max(700,700)-500+200,[e,r]=Qn(),i=q(),s=window.innerHeight,o=screen.availHeight-window.innerHeight,u=Cn(Fn(document.documentElement),Jn(document.documentElement)),c=Ae(Wn("visibilitychange",document))(qe(Nn(()=>document.visibilityState),Rn(document.visibilityState))),h=Ae(u)(qe(Nn(t=>"focusin"===t.type?pt(!1):ht(700,!0)),on,Rn(!nr()),an,En)),f=Ae(Kn(screen.orientation))(qe(Dn(t=>t||window.innerHeight===s,h),Un(700),Nn(t=>({screenOrientation:$e(),height:t?window.innerHeight:screen.availHeight-o})))),a=Ae(h)(qe(Mn(Je(!0)),Nn(()=>({screenOrientation:$e(),height:window.innerHeight})))),p=Ae(Xt([a,f]))(qe(Ln(1e3),tr(Nn(Ve("hidden"),c)),zn((t,{screenOrientation:n,height:e})=>Se(n,e,t),{[$e()]:window.innerHeight}),Vn(Re(Ke,We(["portrait","landscape"]),be)))),l=Ae(Xn(window))(qe(Un(500),Nn(t=>({width:t.target.innerWidth,height:t.target.innerHeight})),zn((t,n)=>({...n,isJustHeightResize:t.width===n.width,dH:n.height-t.height}),{width:window.innerWidth,height:window.innerHeight,isJustHeightResize:!1,dH:0}),Mn(Xe("isJustHeightResize",!0)))),d=Ae(l)(qe(Ln(n),Dn((t,{height:n,dH:e})=>{const r=t[$e()];return r?n<.9*r&&e<0?pt("visible"):n===r&&e>0?pt("hidden"):ot():e>.1*screen.availHeight?pt("hidden"):e<-.1*screen.availHeight?pt("visible"):ot()},p),Jt,Cn(Ae(h)(qe(Mn(Je(!0)),Nn(Te("hidden"))))),Bn(r),an));return qn(Pn(t,d),i),e},Object.defineProperty(t,"__esModule",{value:!0})}));
